define('aim/admin/view/ExportAssignmentLogView',['aim/admin/model/AuthorAssignmentModel',
                                                 'aim/admin/model/ProjectModel',
                                                 'aim/admin/model/ResourceAssignmentModel',
                                               'aim/admin/model/QueryAssignmentLogModel',
                                               'aim/admin/view/SelectProjectView',
                                               'aim/admin/view/SelectResourceView',
                                               'aim/admin/view/SelectAuthorView',
                                               'aim/admin/view/SelectFromView',
                                               'aim/admin/view/SelectToView'], function(
                                            		   AuthorAssignmentModel,
                                            		   ProjectModel,
                                            		   ResourceAssignmentModel,
                                            		   QueryAssignmentLogModel,
                                            		   SelectProjectView,
                                            		   SelectResourceView,
                                            		   SelectAuthorView,
                                            		   SelectFromView,
                                            		   SelectToView) {
	var ExportAssignmentLogView = Backbone.View.extend({
		
		el : '#export-assignment-dialog',
		
		initialize : function() {
			if(this.queryAssignmentLogModel == null)
				this.queryAssignmentLogModel = new QueryAssignmentLogModel();
			this.authorModel = new AuthorAssignmentModel(this.queryAssignmentLogModel);
			this.projectModel = new ProjectModel(this.queryAssignmentLogModel);
			this.resourceModel = new ResourceAssignmentModel(this.queryAssignmentLogModel);
			this.selectAuthorView = new SelectAuthorView({el: ExportAssignmentLogView.selectAuthorEl, model: this.authorModel},{options: this.queryAssignmentLogModel});
			this.selectProjectView = new SelectProjectView({el: ExportAssignmentLogView.selectProjectEl, model: this.projectModel},{options: this.queryAssignmentLogModel});
			this.selectResourceView = new SelectResourceView({el: ExportAssignmentLogView.selectResourceEl, model: this.resourceModel},{options: this.queryAssignmentLogModel});
			this.selectedFromDate = new SelectFromView({el: ExportAssignmentLogView.selectChangeDateEl, model: this.queryAssignmentLogModel});
		},

		events: {
			"change #select-assignment-project"      : "projectSelectChanged",
			"change #select-assignment-resource"     : "resourceSelectChanged",
			"change #select-assignment-author"       : "authorSelectChanged",
			"change #change-assignment-date"         : "fromChanged",
			"click  #export-assignment-save-button"  : "saveExportValues",
			"click  #export-assignment-cancel-button": "cancelExportValues"
		},
		
		render : function() {
			AJS.$(ExportAssignmentLogView.selectChangeDateEl).val('');
			this.authorModel.from = this.queryAssignmentLogModel.from;
			this.authorModel.selectedProject = this.queryAssignmentLogModel.selectedProject;
			this.authorModel.selectedResource = this.queryAssignmentLogModel.selectedResource;
			this.authorModel.author = this.queryAssignmentLogModel.author;
			this.authorModel.save();
			
			this.projectModel.from = this.queryAssignmentLogModel.from;
			this.projectModel.selectedProject = this.queryAssignmentLogModel.selectedProject;
			this.projectModel.selectedResource = this.queryAssignmentLogModel.selectedResource;
			this.projectModel.author = this.queryAssignmentLogModel.author;
			this.projectModel.save();
			
			this.resourceModel.from = this.queryAssignmentLogModel.from;
			this.resourceModel.selectedProject = this.queryAssignmentLogModel.selectedProject;
			this.resourceModel.selectedResource = this.queryAssignmentLogModel.selectedResource;
			this.resourceModel.author = this.queryAssignmentLogModel.author;
			this.resourceModel.save();
			
			this.selectedFromDate.render();
			return this;		
		},
		
		projectSelectChanged : function(event) {
			var value = event.currentTarget.value;
			this.queryAssignmentLogModel.set('selectedProject', value);
		},

		resourceSelectChanged : function(event) {
			var value = event.currentTarget.value;
			this.queryAssignmentLogModel.set('selectedResource', value);
		},

		authorSelectChanged : function(event) {
			var value = event.currentTarget.value;
			this.queryAssignmentLogModel.set('author', value);
		},

		fromChanged : function(event) {
			var value = event.currentTarget.value;
			this.queryAssignmentLogModel.set('from', value);
		},
		
		cancelExportValues : function() {
			AJS.dialog2("#export-assignment-dialog").hide();
		},

		saveExportValues : function() {
			var author = this.queryAssignmentLogModel.get('author') == null ? -1 : this.queryAssignmentLogModel.get('author');
			var selectedProject = this.queryAssignmentLogModel.get('selectedProject') == null ? -1 : this.queryAssignmentLogModel.get('selectedProject');
			var selectedResource = this.queryAssignmentLogModel.get('selectedResource') == null ? -1 : this.queryAssignmentLogModel.get('selectedResource');
			var pickedDate = this.queryAssignmentLogModel.get('from') == null ? -1 : new Date(this.queryAssignmentLogModel.get('from')).getTime();
			if(isNaN(pickedDate))
				pickedDate = -1;
			var popup=window.open(AJS.contextPath() + '/rest/resources/1.0/log/assignmentLog/'+author+'/'+selectedProject+'/'+selectedResource+'/'+pickedDate);
			AJS.dialog2("#export-assignment-dialog").hide();
		}
		
	},{//constants
		selectAuthorEl     : '#select-assignment-author',
		selectResourceEl   : '#select-assignment-resource',
		selectProjectEl    : '#select-assignment-project',
		selectChangeDateEl : '#change-assignment-date'
	});
	return ExportAssignmentLogView;
});