define('aim/admin/view/ExportCapacityLogView',['aim/admin/model/AuthorCapacityModel',
                                               'aim/admin/model/ResourceCapacityModel',
                                               'aim/admin/model/QueryCapacityLogModel',
                                               'aim/admin/view/SelectResourceView',
                                               'aim/admin/view/SelectAuthorView',
                                               'aim/admin/view/SelectFromView',
                                               'aim/admin/view/SelectToView'], function(
                                            		   AuthorCapacityModel,
                                            		   ResourceCapacityModel,
                                            		   QueryCapacityLogModel,
                                            		   SelectResourceView,
                                            		   SelectAuthorView,
                                            		   SelectFromView,
                                            		   SelectToView) {
	var ExportCapacityLogView = Backbone.View.extend({
		
		el : '#export-capacity-dialog',
		
		initialize : function() {
			if(this.queryCapacityLogModel == null)
				this.queryCapacityLogModel = new QueryCapacityLogModel();
			this.authorModel = new AuthorCapacityModel(this.queryCapacityLogModel);
			this.resourceModel = new ResourceCapacityModel(this.queryCapacityLogModel);
			this.selectAuthorView = new SelectAuthorView({el: ExportCapacityLogView.selectAuthorEl, model: this.authorModel},{options: this.queryCapacityLogModel});
			this.selectResourceView = new SelectResourceView({el: ExportCapacityLogView.selectResourceEl, model: this.resourceModel},{options: this.queryCapacityLogModel});
			this.selectedFromDate = new SelectFromView({el: ExportCapacityLogView.selectChangeDateEl, model: this.queryCapacityLogModel});
		},

		events: {
			"change #select-capacity-resource"     : "resourceSelectChanged",
			"change #select-capacity-author"       : "authorSelectChanged",
			"change #change-capacity-date"         : "fromChanged",
			"click #export-capacity-save-button"   : "saveExportValues",
			"click #export-capacity-cancel-button" : "cancelExportValues"
		},
		
		render : function() {
			AJS.$(ExportCapacityLogView.selectChangeDateEl).val('');
			this.authorModel.from = this.queryCapacityLogModel.from;
			this.authorModel.selectedResource = this.queryCapacityLogModel.selectedResource;
			this.authorModel.author = this.queryCapacityLogModel.author;
			this.authorModel.save();
			
			this.authorModel.from = this.queryCapacityLogModel.from;
			this.resourceModel.selectedResource = this.queryCapacityLogModel.selectedResource;
			this.authorModel.author = this.queryCapacityLogModel.author;
			this.resourceModel.save();
			
			this.selectedFromDate.render();
			return this;		
		},
		
		resourceSelectChanged : function(event) {
			var value = event.currentTarget.value;
			this.queryCapacityLogModel.set('selectedResource', value);
		},

		authorSelectChanged : function(event) {
			var value = event.currentTarget.value;
			this.queryCapacityLogModel.set('author', value);
		},

		fromChanged : function(event) {
			var value = event.currentTarget.value;
//			var currentDate = AJS.$(ExportCapacityLogView.selectChangeDateEl).datepicker("getDate");
//			var millis = currentDate.getTime();
			this.queryCapacityLogModel.set('from', value);
		},
		
		cancelExportValues : function() {
			AJS.dialog2("#export-capacity-dialog").hide();
		},

		saveExportValues : function() {
			var author = this.queryCapacityLogModel.get('author') == null ? -1 : this.queryCapacityLogModel.get('author');
			var selectedResource = this.queryCapacityLogModel.get('selectedResource') == null ? -1 : this.queryCapacityLogModel.get('selectedResource');
			var pickedDate = this.queryCapacityLogModel.get('from') == null ? -1 : new Date(this.queryCapacityLogModel.get('from')).getTime();
			if(isNaN(pickedDate))
				pickedDate = -1;
			var popup=window.open(AJS.contextPath() + '/rest/resources/1.0/log/capacityLog/'+author+'/'+selectedResource+'/'+pickedDate);
			AJS.dialog2("#export-capacity-dialog").hide();
		},
		
		onClose: function(){
		    this.model.unbind("change", this.render);
		    this.model.unbind("click", this.render);
		}

		
	},
	{//constants
			selectAuthorEl : '#select-capacity-author',
			selectResourceEl : '#select-capacity-resource',
			selectChangeDateEl : '#change-capacity-date'
	});
	return ExportCapacityLogView;
});