define('aim/analytics/view/AnalyticsProjectView',['aim/analytics/model/AnalyticsProjectWeekModel',
                                                  'aim/analytics/model/AnalyticsWeekModel',
                                                  'aim/analytics/view/WeekProjectView',
                                                  'aim/analytics/view/AnalyticsWeekView'], function(
                                               		   AnalyticsProjectWeekModel,
                                               		   AnalyticsWeekModel,
                                               		   WeekProjectView,
                                               		   AnalyticsWeekView) {
	var AnalyticsProjectView = Backbone.View.extend({
		el: '#content',
		
		initialize : function() {
			this.listenTo(this.model, 'sync', this.render);//the context with the filter data
			this.data = new Array();
		},
			
		render : function() {
			var self = this;
			AJS.$('.analytics-week-project-sum').each(function(iter,element) {
				var el = 'ul-project-'+element.dataset.weekid+'-'+element.dataset.projectid;
				if(el in self.data){
					self.data[el].render();
				}else{
					var analyticsProjectWeekModel = new AnalyticsProjectWeekModel();
					var weekProjectView = new WeekProjectView({el: el, model: analyticsProjectWeekModel });
					analyticsProjectWeekModel.set('year',element.dataset.year);
					analyticsProjectWeekModel.set('weekOfYear',element.dataset.weekid);
					analyticsProjectWeekModel.set('projectId',element.dataset.projectid);
					analyticsProjectWeekModel.save();
					self.data[el] = weekProjectView;
				}
			});
			
			AJS.$('.analytics-week-project-resource').each(function(iter,element) {
				var el = 'ul-project-resource-'+element.dataset.weekid+'-'+element.dataset.projectid+'-'+element.dataset.resourceid;
				if(el in self.data){
					self.data[el].render();
				}else{
					var analyticsWeekModel = new AnalyticsWeekModel();
					var analyticsWeekView = new AnalyticsWeekView({el: el, model: analyticsWeekModel });
					analyticsWeekModel.set('year',element.dataset.year);
					analyticsWeekModel.set('weekOfYear',element.dataset.weekid);
					analyticsWeekModel.set('resourceId',element.dataset.resourceid);
					analyticsWeekModel.set('projectId',element.dataset.projectid);
					analyticsWeekModel.save();
					self.data[el] = analyticsWeekView;
				}
			});
			return this;
		}
	});
	return AnalyticsProjectView;
});