define('aim/analytics/view/AnalyticsResourceView',['aim/analytics/model/AnalyticsResourceWeekModel',
                                                   'aim/analytics/model/AnalyticsWeekModel',
                                                   'aim/analytics/view/WeekResourceView',
                                                   'aim/analytics/view/AnalyticsWeekView'], function(
                                                		   AnalyticsResourceWeekModel,
                                                		   AnalyticsWeekModel,
                                                		   WeekResourceView,
                                                		   AnalyticsWeekView) {
	var AnalyticsResourceView = Backbone.View.extend({
		el: '#content',
		
		initialize : function() {
			this.listenTo(this.model, 'sync', this.render);//the context with the filter data
			this.data = new Array();
		},
			
		render : function() {
			var self = this;
			AJS.$('.analytics-week-resource-sum').each(function(iter,element) {
				var el = 'ul-resource-'+element.dataset.weekid+'-'+element.dataset.resourceid;
				if(el in self.data){
					self.data[el].render();
				}else{
					var analyticsResourceWeekModel = new AnalyticsResourceWeekModel();
					var weekResourceView = new WeekResourceView({el: el, model: analyticsResourceWeekModel });
					analyticsResourceWeekModel.set('year',element.dataset.year);
					analyticsResourceWeekModel.set('weekOfYear',element.dataset.weekid);
					analyticsResourceWeekModel.set('resourceId',element.dataset.resourceid);
					analyticsResourceWeekModel.save();
					self.data[el] = weekResourceView;
				}
			});
			
			AJS.$('.analytics-week-resource-project').each(function(iter,element) {
				var el = 'ul-resource-project-'+element.dataset.weekid+'-'+element.dataset.projectid+'-'+element.dataset.resourceid;
				if(el in self.data){
					self.data[el].render();
				}else{
					var analyticsWeekModel = new AnalyticsWeekModel();
					var analyticsWeekView = new AnalyticsWeekView({el: el, model: analyticsWeekModel });
					analyticsWeekModel.set('year',element.dataset.year);
					analyticsWeekModel.set('weekOfYear',element.dataset.weekid);
					analyticsWeekModel.set('resourceId',element.dataset.resourceid);
					analyticsWeekModel.set('projectId',element.dataset.projectid);
					analyticsWeekModel.save();
					self.data[el] = analyticsWeekView;
				}
			});
			return this;
		}
	});
	return AnalyticsResourceView;
});