define('aim/main/view/RemoveFilterActionView',['aim/main/model/FilterActionModel'], function(FilterActionModel) {
	var RemoveFilterActionView = Backbone.View.extend({
		
		el: "#jira",
		
		events: {
			"click #removeFilter": "removeFilter",
			"click #actionTrigger" : "actionTrigger"
		},
		
		removeFilter : function(event){
			var filterId = event.currentTarget.dataset.filterid;
			var filterName = event.currentTarget.dataset.filtername;
			var filterActionModel = new FilterActionModel(null, 
					{action: event.currentTarget.id, 
					filterId: filterId,
					});
			var baseModel = this.model;
			
			event.preventDefault();
		    AJS.$.get(AJS.$(this).attr('href'), function() {
		        var popup = new AJS.Dialog(500,200, 'aui-your-dialog');
		        var headerText = AJS.I18n.getText("naomi.templates.js.jirarp.plan.board.remove.filter.dialog.header.text");
		        var panelpart1 = AJS.I18n.getText("naomi.templates.js.jirarp.plan.board.remove.filter.dialog.panel.part.1");
		        var panelpart2 = AJS.I18n.getText("naomi.templates.js.jirarp.plan.board.remove.filter.dialog.panel.part.2");
		        var close = AJS.I18n.getText("naomi.templates.js.jirarp.plan.board.remove.filter.dialog.button.cancel");
		        var ok = AJS.I18n.getText("naomi.templates.js.jirarp.plan.board.remove.filter.dialog.button.ok");
		        popup.addHeader( headerText );
		        popup.addPanel( filterName, panelpart1 + filterName + panelpart2 , "panel-body");
		        popup.addButton(close, function (dialog) {dialog.hide();}, 'aui-your-cancel-button');
		        popup.addButton(ok, function (dialog) {
		        	dialog.hide();
		        	filterActionModel.save(null, {success:function(model, res, options) {
						baseModel.fetch();
					}});
		        }, 'aui-your-remove-button');
		        popup.show();
		    }); 
			
		},
		
		actionTrigger : function(event){
			event.stopPropagation();
		},
		
		onClose: function(){
			this.model.unbind("click", this.render);
		}
	});
	return RemoveFilterActionView;
});