define('aim/util/Utils',[], function() {
	return{
		sendMessage: function(type,title,autoClose,message){
			return require(['aui/flag'], function(flag) {
			    var myFlag = flag({
			       type: type,
			       title: title,
			       persistent: false,
			       close: autoClose,
			       body: message
			    });
			    return myFlag;
			});
		},
		replace: function(replacements, stringToReplace){
			stringToReplace = stringToReplace.replace(/%\w+%/g, function(all) {
			   return replacements[all] || all;
			});
			return stringToReplace;
		},
		clearMessageBar: function(selector){
			AJS.$(selector).html('');
		},
		clearFieldMarker: function(fieldsWithMessages){
			if(fieldsWithMessages){
				for (var i in fieldsWithMessages) {
					AJS.$(fieldsWithMessages[i]).removeClass('naomi-input-error');
					AJS.$(fieldsWithMessages[i]).removeClass('naomi-input-warn');
					AJS.$(fieldsWithMessages[i]).removeClass('naomi-input-info');
					}
				fieldsWithMessages = new Array();
			}
		},
		sendBarErrorMessage: function(selector,title,message,fadeout,delay,duration){
			this.clearMessageBar(selector);
			AJS.messages.error(selector, {
				   title: message,
//				   body: message,
				   fadeout: fadeout,
				   delay: delay,
				   duration: duration
				});
		},
		sendBarInfoMessage: function(selector,title,message,fadeout,delay,duration){
			this.clearMessageBar(selector);
			AJS.messages.info(selector, {
				   title: message,
//				   body: message,
				   fadeout: fadeout,
				   delay: delay,
				   duration: duration
				});
		},
		sendBarWarnMessage: function(selector,title,message,fadeout,delay,duration){
			this.clearMessageBar(selector);
			AJS.messages.warning(selector, {
				   title: message,
//				   body: message,
				   fadeout: fadeout,
				   delay: delay,
				   duration: duration
				});
		},
		validateFlagModel: function(model, messageKey, fieldSelector, fieldsWithMessages){
			var errorMessage = model.attributes.errorMessage;
			var warnMessage = model.attributes.warnMessage;
			var infoMessage = model.attributes.infoMessage;
			var isValid = false;
			if(errorMessage){//this is the validation failed message
				var title = AJS.I18n.getText("naomi.templates.js.jirarp.board.message.error.title");
				this.sendMessage('error',title,'manual',errorMessage);
				this.markFieldWithError(fieldSelector,fieldsWithMessages);
			}else if(warnMessage){//this is the validation failed message
				var title = AJS.I18n.getText("naomi.templates.js.jirarp.board.message.warn.title");
				this.sendMessage('warning',title,'auto',warnMessage);
				this.markFieldWithWarn(fieldSelector,fieldsWithMessages);
				isValid = true;
			}else if(infoMessage){
				var title = AJS.I18n.getText("naomi.templates.js.jirarp.board.message.info.title");
				this.sendMessage('info',title,'auto',infoMessage);
				this.markFieldWithInfo(fieldSelector,fieldsWithMessages);
				isValid = true;
			}else{
				if(fieldSelector){//only clear this field, others stay
					this.unmarkField(fieldSelector, fieldsWithMessages);
				}else{
					this.clearFieldMarker(fieldsWithMessages);
				}
				isValid = true;
			}
			return isValid;
		},
		validateBarModel: function(model, messageKey, barSelector, fieldSelector, fieldsWithMessages){
			var errorMessage = model.attributes.errorMessage;
			var warnMessage = model.attributes.warnMessage;
			var infoMessage = model.attributes.infoMessage;
			var isValid = false;
			if(errorMessage){//this is the validation failed message
				var title = AJS.I18n.getText(messageKey + '.error.title');
				this.sendBarErrorMessage(barSelector, title, model.attributes.errorMessage, false, 5000, 500);
				this.markFieldWithError(fieldSelector,fieldsWithMessages);
			}else if(warnMessage){
				var title = AJS.I18n.getText(messageKey + '.warn.title');
				this.sendBarWarnMessage(barSelector, title, model.attributes.warnMessage, true, 5000, 500);
				this.markFieldWithWarn(fieldSelector,fieldsWithMessages);
				isValid = true;
			}else if(infoMessage){
				var title = AJS.I18n.getText(messageKey + '.info.title');
				this.sendBarInfoMessage(barSelector, title, model.attributes.infoMessage, true, 5000, 500);
				this.markFieldWithInfo(fieldSelector,fieldsWithMessages);
				isValid = true;
			}else{
				if(fieldSelector){//only clear this field, others stay
					this.unmarkField(fieldSelector, fieldsWithMessages, barSelector);
				}else{
					this.clearMessageBar(barSelector);
				}
				isValid = true;
			}
			return isValid;
		},
		markFieldWithError: function(fieldSelector, fieldsWithMessages){
			if(fieldSelector && fieldsWithMessages){
				AJS.$(fieldSelector).addClass('naomi-input-error');
				if(! _.contains(fieldsWithMessages, fieldSelector)){
					fieldsWithMessages.push(fieldSelector);
				}
			}
		},
		markFieldWithWarn: function(fieldSelector, fieldsWithMessages){
			if(fieldSelector && fieldsWithMessages){
				AJS.$(fieldSelector).addClass('naomi-input-warn');
				if(! _.contains(fieldsWithMessages, fieldSelector)){
					fieldsWithMessages.push(fieldSelector);
				}
			}
		},
		markFieldWithInfo: function(fieldSelector, fieldsWithMessages){
			if(fieldSelector && fieldsWithMessages){
				AJS.$(fieldSelector).addClass('naomi-input-info');
				if(! _.contains(fieldsWithMessages, fieldSelector)){
					fieldsWithMessages.push(fieldSelector);
				}
			}
		},		
		unmarkField: function(fieldSelector, fieldsWithMessages, barSelector){
			if(fieldSelector && fieldsWithMessages){
				AJS.$(fieldSelector).removeClass('naomi-input-error');
				AJS.$(fieldSelector).removeClass('naomi-input-warn');
				AJS.$(fieldSelector).removeClass('naomi-input-info');
				fieldsWithMessages.pop(fieldSelector);
				if(fieldsWithMessages.length == 0 && barSelector)
					this.clearMessageBar(barSelector);
			}
		}
	}	
});