var constants = {
		resourceMode : "resources",
		projectMode : "projects",
		resourceOnly : "resourceOnly",
		analyticsProjectMode : "analyticsProject",
		analyticsResourceMode : "analyticsResource",
		analyticsResourceOnlyMode : "analyticsResourceOnly"
};

jQuery(document).ready(function($) {
	require(['aui/form-notification']);
	require(['aui/flag']);
	if (!String.prototype.endsWith) {
		  String.prototype.endsWith = function(searchString, position) {
		      var subjectString = this.toString();
		      if (position === undefined || position > subjectString.length) {
		        position = subjectString.length;
		      }
		      position -= searchString.length;
		      var lastIndex = subjectString.indexOf(searchString, position);
		      return lastIndex !== -1 && lastIndex === position;
		  };
		}
	
	jQuery.fn.filterByText = function(textbox) {
	    return this.each(function() {
	        var select = this;
	        var options = [];
	        $(select).find('option').each(function() {
	            options.push({value: $(this).val(), text: $(this).text()});
	        });
	        $(select).data('options', options);

	        $(textbox).bind('change keyup', function() {
	            var options = $(select).empty().data('options');
	            var search = $.trim($(this).val());
	            var regex = new RegExp(search,"gi");

	            $.each(options, function(i) {
	                var option = options[i];
	                if(option.text.match(regex) !== null) {
	                    $(select).append(
	                        $('<option>').text(option.text).val(option.value)
	                    );
	                }
	            });
	        });
	    });
	};
	var opt_data = {};
	opt_data.renderProjectsInFilter = "show";
	
	$("#plan-sidebar").replaceWith(Naomi.Templates.Filter.sidebar());
	$("#new-resource-filter-dialog").replaceWith(Naomi.Templates.JiraRp.newFilterPopup(opt_data));
	
	var ContextModel = new require('aim/assignment/model/ContextModel');
	var contextModel = new ContextModel();
	var WeekDataModel = new require('aim/assignment/model/WeekDataModel');
	var weekDataModel = new WeekDataModel();
//	var PlanValueModel = new require('aim/assignment/model/PlanValueModel');
//	var planValueModel = new PlanValueModel();
	var NewFilterModel = new require('aim/assignment/model/NewFilterModel');
	var newFilterModel = new NewFilterModel();
	var FilterContextModel = new require('aim/assignment/model/FilterContextModel');
	var filterContextModel = new FilterContextModel();

//	var contextPlanModel = new ContextPlanModel({newFilterModel : newFilterModel, planValueModel: planValueModel, contextModel : contextModel});
	var ContextPlanModel = new require('aim/assignment/model/ContextPlanModel');
	var filterModel = new ContextPlanModel({newFilterModel : newFilterModel, filterContextModel: filterContextModel, contextModel : contextModel})
	var boardContextModel = new ContextPlanModel({contextModel : contextModel, filterContextModel: filterContextModel});
	
//	var PlanValueView = new require('aim/assignment/view/PlanValueView');
//	var planValueView = new PlanValueView({model: contextPlanModel});
	var BoardMainView = new require('aim/assignment/view/BoardMainView');
	var boardMainView = new BoardMainView({model: contextModel, weekDataModel: weekDataModel});	

	var FilteredNameView = new require('aim/assignment/view/FilteredNameView');
	var filteredNameView = new FilteredNameView(({model: filterModel}))
	var PersonalFilterView = new require('aim/assignment/view/PersonalFilterView');
	var personalFilterView = new PersonalFilterView({model: boardContextModel});
	var FavoriteFilterView = new require('aim/assignment/view/FavoriteFilterView');
	var favoriteFilterView = new FavoriteFilterView({model: boardContextModel});
//	var searchFilterPopupView = new SearchFilterPopupView();
	var PlanSidebarView = new require('aim/assignment/view/PlanSidebarView');
	var planSidebarView = new PlanSidebarView({model: filterModel});
	var NewFilterPopupView = new require('aim/assignment/view/NewFilterPopupView');
	var newFilterPopupView = new NewFilterPopupView({model: filterModel});

});
